<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for APIRiscV.py: 83%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>APIRiscV.py</b> :
            <span class="pc_cov">83%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            173 statements &nbsp;
            <span class="run shortkey_r button_toggle_run">143 run</span>
            <span class="mis show_mis shortkey_m button_toggle_mis">30 missing</span>
            <span class="exc show_exc shortkey_x button_toggle_exc">0 excluded</span>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="pln"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="com">#!/usr/bin/python3</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="pln"><span class="n"><a href="#t2">2</a></span><span class="t"><span class="com"># -*- coding: utf-8 -*-</span>&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="pln"><span class="n"><a href="#t3">3</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="run"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="key">import</span> <span class="nam">networkx</span> <span class="key">as</span> <span class="nam">nx</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="run"><span class="n"><a href="#t5">5</a></span><span class="t"><span class="key">import</span> <span class="nam">graphviz</span> <span class="key">as</span> <span class="nam">gz</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="pln"><span class="n"><a href="#t6">6</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="run"><span class="n"><a href="#t7">7</a></span><span class="t"><span class="key">from</span> <span class="nam">Operands</span> <span class="key">import</span> <span class="op">(</span><span class="nam">Condition</span><span class="op">,</span> <span class="nam">Immediate</span><span class="op">,</span> <span class="nam">Offset</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="pln"><span class="n"><a href="#t8">8</a></span><span class="t">                      <span class="nam">TemporaryPool</span><span class="op">,</span> <span class="nam">Function</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="pln"><span class="n"><a href="#t9">9</a></span><span class="t">                      <span class="nam">A0</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="pln"><span class="n"><a href="#t10">10</a></span><span class="t">                      <span class="nam">ZERO</span><span class="op">,</span> <span class="nam">S</span><span class="op">,</span> <span class="nam">T</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="run"><span class="n"><a href="#t11">11</a></span><span class="t"><span class="key">from</span> <span class="nam">Instruction3A</span> <span class="key">import</span> <span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="pln"><span class="n"><a href="#t12">12</a></span><span class="t">    <span class="nam">Instruction</span><span class="op">,</span> <span class="nam">Instru3A</span><span class="op">,</span> <span class="nam">Comment</span><span class="op">,</span> <span class="nam">Label</span>&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="pln"><span class="n"><a href="#t13">13</a></span><span class="t"><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="pln"><span class="n"><a href="#t14">14</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="pln"><span class="n"><a href="#t15">15</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="pln"><span class="n"><a href="#t16">16</a></span><span class="t"><span class="str">MIF08, CAP, CodeGeneration, RiscV API</span>&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="pln"><span class="n"><a href="#t17">17</a></span><span class="t"><span class="str"> Classes for a RiscV program: constructors, allocation, dump.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="pln"><span class="n"><a href="#t18">18</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="pln"><span class="n"><a href="#t19">19</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="pln"><span class="n"><a href="#t20">20</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="run"><span class="n"><a href="#t21">21</a></span><span class="t"><span class="key">class</span> <span class="nam">RiscVFunction</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="pln"><span class="n"><a href="#t22">22</a></span><span class="t">    <span class="str">"""Representation of a RiscV program (i.e. list of</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="pln"><span class="n"><a href="#t23">23</a></span><span class="t"><span class="str">    instructions)."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="pln"><span class="n"><a href="#t24">24</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="run"><span class="n"><a href="#t25">25</a></span><span class="t">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="run"><span class="n"><a href="#t26">26</a></span><span class="t">        <span class="nam">Instruction</span><span class="op">.</span><span class="nam">count</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="run"><span class="n"><a href="#t27">27</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="run"><span class="n"><a href="#t28">28</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_nbtmp</span> <span class="op">=</span> <span class="op">-</span><span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="run"><span class="n"><a href="#t29">29</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">=</span> <span class="op">-</span><span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="run"><span class="n"><a href="#t30">30</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_dec</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="run"><span class="n"><a href="#t31">31</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_pool</span> <span class="op">=</span> <span class="nam">TemporaryPool</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="run"><span class="n"><a href="#t32">32</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_stacksize</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="run"><span class="n"><a href="#t33">33</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_name</span> <span class="op">=</span> <span class="nam">name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="pln"><span class="n"><a href="#t34">34</a></span><span class="t">        <span class="com"># CFG Stuff - Lab 5 Only</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="run"><span class="n"><a href="#t35">35</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_start</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="run"><span class="n"><a href="#t36">36</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_end</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="pln"><span class="n"><a href="#t37">37</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="run"><span class="n"><a href="#t38">38</a></span><span class="t">    <span class="key">def</span> <span class="nam">add_edge</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">src</span><span class="op">,</span> <span class="nam">dest</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="run"><span class="n"><a href="#t39">39</a></span><span class="t">        <span class="nam">dest</span><span class="op">.</span><span class="nam">_in</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">src</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="run"><span class="n"><a href="#t40">40</a></span><span class="t">        <span class="nam">src</span><span class="op">.</span><span class="nam">_out</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">dest</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="pln"><span class="n"><a href="#t41">41</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="run"><span class="n"><a href="#t42">42</a></span><span class="t">    <span class="key">def</span> <span class="nam">add_instruction</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">i</span><span class="op">,</span> <span class="nam">linkwithsucc</span><span class="op">=</span><span class="key">True</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="pln"><span class="n"><a href="#t43">43</a></span><span class="t">        <span class="str">"""Utility function to add an instruction in the program.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="pln"><span class="n"><a href="#t44">44</a></span><span class="t"><span class="str">        in Lab 4, only add at the end of the instruction list (_listIns)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="pln"><span class="n"><a href="#t45">45</a></span><span class="t"><span class="str">        in Lab 5, will be used to also add in the CFG structure.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="pln"><span class="n"><a href="#t46">46</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="run"><span class="n"><a href="#t47">47</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">:</span>  <span class="com"># empty list: empty prg</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="run"><span class="n"><a href="#t48">48</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">_start</span> <span class="op">=</span> <span class="nam">i</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="pln"><span class="n"><a href="#t49">49</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="run"><span class="n"><a href="#t50">50</a></span><span class="t">            <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_end</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="run"><span class="n"><a href="#t51">51</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">add_edge</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_end</span><span class="op">,</span> <span class="nam">i</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="run"><span class="n"><a href="#t52">52</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_end</span> <span class="op">=</span> <span class="nam">i</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="run"><span class="n"><a href="#t53">53</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">linkwithsucc</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="run"><span class="n"><a href="#t54">54</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">_end</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="run"><span class="n"><a href="#t55">55</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">i</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="run"><span class="n"><a href="#t56">56</a></span><span class="t">        <span class="key">return</span> <span class="nam">i</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="pln"><span class="n"><a href="#t57">57</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="run"><span class="n"><a href="#t58">58</a></span><span class="t">    <span class="key">def</span> <span class="nam">iter_instructions</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">f</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="pln"><span class="n"><a href="#t59">59</a></span><span class="t">        <span class="str">"""Iterate over instructions.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="pln"><span class="n"><a href="#t60">60</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="pln"><span class="n"><a href="#t61">61</a></span><span class="t"><span class="str">        For each real instruction (not label or comment), call f,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="pln"><span class="n"><a href="#t62">62</a></span><span class="t"><span class="str">        which must return either None or a list of instruction. If it</span>&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="pln"><span class="n"><a href="#t63">63</a></span><span class="t"><span class="str">        returns None, nothing happens. If it returns a list, then the</span>&nbsp;</span><span class="r"></span></p>
    <p id="t64" class="pln"><span class="n"><a href="#t64">64</a></span><span class="t"><span class="str">        instruction is replaced by this list.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t65" class="pln"><span class="n"><a href="#t65">65</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t66" class="pln"><span class="n"><a href="#t66">66</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t67" class="run"><span class="n"><a href="#t67">67</a></span><span class="t">        <span class="nam">i</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t68" class="run"><span class="n"><a href="#t68">68</a></span><span class="t">        <span class="key">while</span> <span class="nam">i</span> <span class="op">&lt;</span> <span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t69" class="run"><span class="n"><a href="#t69">69</a></span><span class="t">            <span class="nam">old_i</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t70" class="run"><span class="n"><a href="#t70">70</a></span><span class="t">            <span class="key">if</span> <span class="key">not</span> <span class="nam">old_i</span><span class="op">.</span><span class="nam">is_instruction</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t71" class="run"><span class="n"><a href="#t71">71</a></span><span class="t">                <span class="nam">i</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t72" class="run"><span class="n"><a href="#t72">72</a></span><span class="t">                <span class="key">continue</span>&nbsp;</span><span class="r"></span></p>
    <p id="t73" class="run"><span class="n"><a href="#t73">73</a></span><span class="t">            <span class="nam">new_i_list</span> <span class="op">=</span> <span class="nam">f</span><span class="op">(</span><span class="nam">old_i</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t74" class="run"><span class="n"><a href="#t74">74</a></span><span class="t">            <span class="key">if</span> <span class="nam">new_i_list</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t75" class="mis show_mis"><span class="n"><a href="#t75">75</a></span><span class="t">                <span class="nam">i</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t76" class="mis show_mis"><span class="n"><a href="#t76">76</a></span><span class="t">                <span class="key">continue</span>&nbsp;</span><span class="r"></span></p>
    <p id="t77" class="run"><span class="n"><a href="#t77">77</a></span><span class="t">            <span class="key">del</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t78" class="run"><span class="n"><a href="#t78">78</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">.</span><span class="nam">insert</span><span class="op">(</span><span class="nam">i</span><span class="op">,</span> <span class="nam">Comment</span><span class="op">(</span><span class="nam">str</span><span class="op">(</span><span class="nam">old_i</span><span class="op">)</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t79" class="run"><span class="n"><a href="#t79">79</a></span><span class="t">            <span class="nam">i</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t80" class="run"><span class="n"><a href="#t80">80</a></span><span class="t">            <span class="key">for</span> <span class="nam">new_i</span> <span class="key">in</span> <span class="nam">new_i_list</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t81" class="run"><span class="n"><a href="#t81">81</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">.</span><span class="nam">insert</span><span class="op">(</span><span class="nam">i</span><span class="op">,</span> <span class="nam">new_i</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t82" class="run"><span class="n"><a href="#t82">82</a></span><span class="t">                <span class="nam">i</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t83" class="run"><span class="n"><a href="#t83">83</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">.</span><span class="nam">insert</span><span class="op">(</span><span class="nam">i</span><span class="op">,</span> <span class="nam">Comment</span><span class="op">(</span><span class="str">"end "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">old_i</span><span class="op">)</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t84" class="run"><span class="n"><a href="#t84">84</a></span><span class="t">            <span class="nam">i</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t85" class="pln"><span class="n"><a href="#t85">85</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t86" class="run"><span class="n"><a href="#t86">86</a></span><span class="t">    <span class="key">def</span> <span class="nam">get_instructions</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t87" class="run"><span class="n"><a href="#t87">87</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span>&nbsp;</span><span class="r"></span></p>
    <p id="t88" class="pln"><span class="n"><a href="#t88">88</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t89" class="run"><span class="n"><a href="#t89">89</a></span><span class="t">    <span class="key">def</span> <span class="nam">new_tmp</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t90" class="pln"><span class="n"><a href="#t90">90</a></span><span class="t">        <span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t91" class="pln"><span class="n"><a href="#t91">91</a></span><span class="t"><span class="str">        Return a new fresh temporary (temp)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t92" class="pln"><span class="n"><a href="#t92">92</a></span><span class="t"><span class="str">        + add in list</span>&nbsp;</span><span class="r"></span></p>
    <p id="t93" class="pln"><span class="n"><a href="#t93">93</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t94" class="run"><span class="n"><a href="#t94">94</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_pool</span><span class="op">.</span><span class="nam">new_tmp</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t95" class="pln"><span class="n"><a href="#t95">95</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t96" class="run"><span class="n"><a href="#t96">96</a></span><span class="t">    <span class="key">def</span> <span class="nam">new_offset</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">base</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t97" class="pln"><span class="n"><a href="#t97">97</a></span><span class="t">        <span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t98" class="pln"><span class="n"><a href="#t98">98</a></span><span class="t"><span class="str">        Return a new offset in the memory stack</span>&nbsp;</span><span class="r"></span></p>
    <p id="t99" class="pln"><span class="n"><a href="#t99">99</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t100" class="run"><span class="n"><a href="#t100">100</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_dec</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_dec</span> <span class="op">+</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t101" class="run"><span class="n"><a href="#t101">101</a></span><span class="t">        <span class="key">return</span> <span class="nam">Offset</span><span class="op">(</span><span class="nam">base</span><span class="op">,</span> <span class="op">-</span><span class="num">8</span> <span class="op">*</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_dec</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t102" class="pln"><span class="n"><a href="#t102">102</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t103" class="run"><span class="n"><a href="#t103">103</a></span><span class="t">    <span class="key">def</span> <span class="nam">get_offset</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t104" class="run"><span class="n"><a href="#t104">104</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_dec</span>&nbsp;</span><span class="r"></span></p>
    <p id="t105" class="pln"><span class="n"><a href="#t105">105</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t106" class="run"><span class="n"><a href="#t106">106</a></span><span class="t">    <span class="key">def</span> <span class="nam">get_stacksize</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t107" class="run"><span class="n"><a href="#t107">107</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_stacksize</span>&nbsp;</span><span class="r"></span></p>
    <p id="t108" class="pln"><span class="n"><a href="#t108">108</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t109" class="run"><span class="n"><a href="#t109">109</a></span><span class="t">    <span class="key">def</span> <span class="nam">new_label</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t110" class="pln"><span class="n"><a href="#t110">110</a></span><span class="t">        <span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t111" class="pln"><span class="n"><a href="#t111">111</a></span><span class="t"><span class="str">        Return a new label</span>&nbsp;</span><span class="r"></span></p>
    <p id="t112" class="pln"><span class="n"><a href="#t112">112</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t113" class="run"><span class="n"><a href="#t113">113</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">+</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t114" class="run"><span class="n"><a href="#t114">114</a></span><span class="t">        <span class="key">return</span> <span class="nam">Label</span><span class="op">(</span><span class="nam">name</span> <span class="op">+</span> <span class="str">"_"</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t115" class="pln"><span class="n"><a href="#t115">115</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t116" class="run"><span class="n"><a href="#t116">116</a></span><span class="t">    <span class="key">def</span> <span class="nam">new_label_while</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t117" class="run"><span class="n"><a href="#t117">117</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">+</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t118" class="run"><span class="n"><a href="#t118">118</a></span><span class="t">        <span class="key">return</span> <span class="op">(</span><span class="nam">Label</span><span class="op">(</span><span class="str">"l_while_begin_"</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span><span class="op">)</span><span class="op">)</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t119" class="pln"><span class="n"><a href="#t119">119</a></span><span class="t">                <span class="nam">Label</span><span class="op">(</span><span class="str">"l_while_end_"</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span><span class="op">)</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t120" class="pln"><span class="n"><a href="#t120">120</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t121" class="run"><span class="n"><a href="#t121">121</a></span><span class="t">    <span class="key">def</span> <span class="nam">new_label_cond</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t122" class="run"><span class="n"><a href="#t122">122</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span> <span class="op">+</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t123" class="run"><span class="n"><a href="#t123">123</a></span><span class="t">        <span class="key">return</span> <span class="op">(</span><span class="nam">Label</span><span class="op">(</span><span class="str">"l_cond_neg_"</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span><span class="op">)</span><span class="op">)</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t124" class="pln"><span class="n"><a href="#t124">124</a></span><span class="t">                <span class="nam">Label</span><span class="op">(</span><span class="str">"l_cond_end_"</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_nblabel</span><span class="op">)</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t125" class="pln"><span class="n"><a href="#t125">125</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t126" class="pln"><span class="n"><a href="#t126">126</a></span><span class="t">    <span class="com"># each instruction has its own "add in list" version</span>&nbsp;</span><span class="r"></span></p>
    <p id="t127" class="run"><span class="n"><a href="#t127">127</a></span><span class="t">    <span class="key">def</span> <span class="nam">addLabel</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">s</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t128" class="run"><span class="n"><a href="#t128">128</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">s</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t129" class="pln"><span class="n"><a href="#t129">129</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t130" class="run"><span class="n"><a href="#t130">130</a></span><span class="t">    <span class="key">def</span> <span class="nam">addComment</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">s</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t131" class="run"><span class="n"><a href="#t131">131</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">Comment</span><span class="op">(</span><span class="nam">s</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t132" class="pln"><span class="n"><a href="#t132">132</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t133" class="run"><span class="n"><a href="#t133">133</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionPRINTINT</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">reg</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t134" class="pln"><span class="n"><a href="#t134">134</a></span><span class="t">        <span class="str">"""Print integer value, with newline. (see Expand)"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t135" class="pln"><span class="n"><a href="#t135">135</a></span><span class="t">        <span class="com"># a print instruction generates the temp it prints.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t136" class="run"><span class="n"><a href="#t136">136</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"mv"</span><span class="op">,</span> <span class="nam">A0</span><span class="op">,</span> <span class="nam">reg</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t137" class="run"><span class="n"><a href="#t137">137</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t138" class="run"><span class="n"><a href="#t138">138</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">addInstructionCALL</span><span class="op">(</span><span class="str">'println_int'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t139" class="pln"><span class="n"><a href="#t139">139</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t140" class="pln"><span class="n"><a href="#t140">140</a></span><span class="t">    <span class="com"># Other printing instructions are not implemented.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t141" class="pln"><span class="n"><a href="#t141">141</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t142" class="run"><span class="n"><a href="#t142">142</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionCALL</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">function</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t143" class="run"><span class="n"><a href="#t143">143</a></span><span class="t">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">function</span><span class="op">,</span> <span class="nam">str</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t144" class="run"><span class="n"><a href="#t144">144</a></span><span class="t">            <span class="nam">function</span> <span class="op">=</span> <span class="nam">Function</span><span class="op">(</span><span class="nam">function</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t145" class="run"><span class="n"><a href="#t145">145</a></span><span class="t">        <span class="key">assert</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">function</span><span class="op">,</span> <span class="nam">Function</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t146" class="run"><span class="n"><a href="#t146">146</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">Instru3A</span><span class="op">(</span><span class="str">'call'</span><span class="op">,</span> <span class="nam">function</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t147" class="pln"><span class="n"><a href="#t147">147</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t148" class="pln"><span class="n"><a href="#t148">148</a></span><span class="t">    <span class="com"># Unconditional jump to label.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t149" class="run"><span class="n"><a href="#t149">149</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionJUMP</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">label</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t150" class="run"><span class="n"><a href="#t150">150</a></span><span class="t">        <span class="key">assert</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">label</span><span class="op">,</span> <span class="nam">Label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t151" class="run"><span class="n"><a href="#t151">151</a></span><span class="t">        <span class="nam">i</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"j"</span><span class="op">,</span> <span class="nam">label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t152" class="pln"><span class="n"><a href="#t152">152</a></span><span class="t">        <span class="com"># add in list but do not link with the following node</span>&nbsp;</span><span class="r"></span></p>
    <p id="t153" class="run"><span class="n"><a href="#t153">153</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">i</span><span class="op">,</span> <span class="nam">linkwithsucc</span><span class="op">=</span><span class="key">False</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t154" class="run"><span class="n"><a href="#t154">154</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_edge</span><span class="op">(</span><span class="nam">i</span><span class="op">,</span> <span class="nam">label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t155" class="run"><span class="n"><a href="#t155">155</a></span><span class="t">        <span class="key">return</span> <span class="nam">i</span>&nbsp;</span><span class="r"></span></p>
    <p id="t156" class="pln"><span class="n"><a href="#t156">156</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t157" class="pln"><span class="n"><a href="#t157">157</a></span><span class="t">    <span class="com"># Conditional jump</span>&nbsp;</span><span class="r"></span></p>
    <p id="t158" class="run"><span class="n"><a href="#t158">158</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionCondJUMP</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">label</span><span class="op">,</span> <span class="nam">op1</span><span class="op">,</span> <span class="nam">c</span><span class="op">,</span> <span class="nam">op2</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t159" class="run"><span class="n"><a href="#t159">159</a></span><span class="t">        <span class="key">assert</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">label</span><span class="op">,</span> <span class="nam">Label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t160" class="run"><span class="n"><a href="#t160">160</a></span><span class="t">        <span class="key">assert</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">c</span><span class="op">,</span> <span class="nam">Condition</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t161" class="run"><span class="n"><a href="#t161">161</a></span><span class="t">        <span class="key">if</span> <span class="nam">op2</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t162" class="run"><span class="n"><a href="#t162">162</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="nam">c</span><span class="op">.</span><span class="nam">__str__</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="nam">op1</span><span class="op">,</span> <span class="nam">op2</span><span class="op">,</span> <span class="nam">label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t163" class="pln"><span class="n"><a href="#t163">163</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t164" class="run"><span class="n"><a href="#t164">164</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="nam">c</span><span class="op">.</span><span class="nam">__str__</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="nam">op1</span><span class="op">,</span> <span class="nam">ZERO</span><span class="op">,</span> <span class="nam">label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t165" class="run"><span class="n"><a href="#t165">165</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t166" class="run"><span class="n"><a href="#t166">166</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_edge</span><span class="op">(</span><span class="nam">ins</span><span class="op">,</span> <span class="nam">label</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t167" class="run"><span class="n"><a href="#t167">167</a></span><span class="t">        <span class="key">return</span> <span class="nam">ins</span>&nbsp;</span><span class="r"></span></p>
    <p id="t168" class="pln"><span class="n"><a href="#t168">168</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t169" class="run"><span class="n"><a href="#t169">169</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionADD</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t170" class="run"><span class="n"><a href="#t170">170</a></span><span class="t">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">sr2orimm7</span><span class="op">,</span> <span class="nam">Immediate</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t171" class="mis show_mis"><span class="n"><a href="#t171">171</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"addi"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t172" class="pln"><span class="n"><a href="#t172">172</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t173" class="run"><span class="n"><a href="#t173">173</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"add"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t174" class="run"><span class="n"><a href="#t174">174</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t175" class="pln"><span class="n"><a href="#t175">175</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t176" class="run"><span class="n"><a href="#t176">176</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionMUL</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t177" class="run"><span class="n"><a href="#t177">177</a></span><span class="t">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">sr2orimm7</span><span class="op">,</span> <span class="nam">Immediate</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t178" class="mis show_mis"><span class="n"><a href="#t178">178</a></span><span class="t">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">"Cant multiply by an immediate"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t179" class="pln"><span class="n"><a href="#t179">179</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t180" class="run"><span class="n"><a href="#t180">180</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"mul"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t181" class="run"><span class="n"><a href="#t181">181</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t182" class="pln"><span class="n"><a href="#t182">182</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t183" class="run"><span class="n"><a href="#t183">183</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionDIV</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t184" class="run"><span class="n"><a href="#t184">184</a></span><span class="t">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">sr2orimm7</span><span class="op">,</span> <span class="nam">Immediate</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t185" class="mis show_mis"><span class="n"><a href="#t185">185</a></span><span class="t">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">"Cant divide by an immediate"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t186" class="pln"><span class="n"><a href="#t186">186</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t187" class="run"><span class="n"><a href="#t187">187</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"div"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t188" class="run"><span class="n"><a href="#t188">188</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t189" class="pln"><span class="n"><a href="#t189">189</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t190" class="run"><span class="n"><a href="#t190">190</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionREM</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t191" class="run"><span class="n"><a href="#t191">191</a></span><span class="t">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">sr2orimm7</span><span class="op">,</span> <span class="nam">Immediate</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t192" class="mis show_mis"><span class="n"><a href="#t192">192</a></span><span class="t">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">"Cant divide by an immediate"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t193" class="pln"><span class="n"><a href="#t193">193</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t194" class="run"><span class="n"><a href="#t194">194</a></span><span class="t">            <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"rem"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t195" class="run"><span class="n"><a href="#t195">195</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t196" class="pln"><span class="n"><a href="#t196">196</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t197" class="run"><span class="n"><a href="#t197">197</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionNOT</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t198" class="mis show_mis"><span class="n"><a href="#t198">198</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"not"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t199" class="mis show_mis"><span class="n"><a href="#t199">199</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t200" class="pln"><span class="n"><a href="#t200">200</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t201" class="run"><span class="n"><a href="#t201">201</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionSUB</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t202" class="run"><span class="n"><a href="#t202">202</a></span><span class="t">        <span class="key">assert</span> <span class="key">not</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">sr2orimm7</span><span class="op">,</span> <span class="nam">Immediate</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t203" class="run"><span class="n"><a href="#t203">203</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"sub"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t204" class="run"><span class="n"><a href="#t204">204</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t205" class="pln"><span class="n"><a href="#t205">205</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t206" class="run"><span class="n"><a href="#t206">206</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionAND</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t207" class="run"><span class="n"><a href="#t207">207</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"and"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t208" class="run"><span class="n"><a href="#t208">208</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t209" class="pln"><span class="n"><a href="#t209">209</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t210" class="run"><span class="n"><a href="#t210">210</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionOR</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t211" class="run"><span class="n"><a href="#t211">211</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"or"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr1</span><span class="op">,</span> <span class="nam">sr2orimm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t212" class="run"><span class="n"><a href="#t212">212</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t213" class="pln"><span class="n"><a href="#t213">213</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t214" class="pln"><span class="n"><a href="#t214">214</a></span><span class="t">    <span class="com"># Copy values (immediate or in register)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t215" class="run"><span class="n"><a href="#t215">215</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionLI</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">imm7</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t216" class="run"><span class="n"><a href="#t216">216</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"li"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">imm7</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t217" class="run"><span class="n"><a href="#t217">217</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t218" class="pln"><span class="n"><a href="#t218">218</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t219" class="run"><span class="n"><a href="#t219">219</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionMV</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t220" class="run"><span class="n"><a href="#t220">220</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"mv"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">sr</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t221" class="run"><span class="n"><a href="#t221">221</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t222" class="pln"><span class="n"><a href="#t222">222</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t223" class="run"><span class="n"><a href="#t223">223</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionLD</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">mem</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t224" class="mis show_mis"><span class="n"><a href="#t224">224</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"ld"</span><span class="op">,</span> <span class="nam">dr</span><span class="op">,</span> <span class="nam">mem</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t225" class="mis show_mis"><span class="n"><a href="#t225">225</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t226" class="pln"><span class="n"><a href="#t226">226</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t227" class="run"><span class="n"><a href="#t227">227</a></span><span class="t">    <span class="key">def</span> <span class="nam">addInstructionSD</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sr</span><span class="op">,</span> <span class="nam">mem</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t228" class="mis show_mis"><span class="n"><a href="#t228">228</a></span><span class="t">        <span class="nam">ins</span> <span class="op">=</span> <span class="nam">Instru3A</span><span class="op">(</span><span class="str">"sd"</span><span class="op">,</span> <span class="nam">sr</span><span class="op">,</span> <span class="nam">mem</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t229" class="mis show_mis"><span class="n"><a href="#t229">229</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_instruction</span><span class="op">(</span><span class="nam">ins</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t230" class="pln"><span class="n"><a href="#t230">230</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t231" class="pln"><span class="n"><a href="#t231">231</a></span><span class="t">    <span class="com"># Dump code</span>&nbsp;</span><span class="r"></span></p>
    <p id="t232" class="run"><span class="n"><a href="#t232">232</a></span><span class="t">    <span class="key">def</span> <span class="nam">printCode</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">output</span><span class="op">,</span> <span class="nam">comment</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t233" class="pln"><span class="n"><a href="#t233">233</a></span><span class="t">        <span class="com"># compute size for the local stack - do not forget to align by 16</span>&nbsp;</span><span class="r"></span></p>
    <p id="t234" class="run"><span class="n"><a href="#t234">234</a></span><span class="t">        <span class="nam">fo</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_stacksize</span><span class="op">(</span><span class="op">)</span>  <span class="com"># allocate enough memory for stack</span>&nbsp;</span><span class="r"></span></p>
    <p id="t235" class="run"><span class="n"><a href="#t235">235</a></span><span class="t">        <span class="nam">cardoffset</span> <span class="op">=</span> <span class="num">8</span> <span class="op">*</span> <span class="op">(</span><span class="nam">fo</span> <span class="op">+</span> <span class="op">(</span><span class="num">0</span> <span class="key">if</span> <span class="nam">fo</span> <span class="op">%</span> <span class="num">2</span> <span class="op">==</span> <span class="num">0</span> <span class="key">else</span> <span class="num">1</span><span class="op">)</span><span class="op">)</span> <span class="op">+</span> <span class="num">16</span>&nbsp;</span><span class="r"></span></p>
    <p id="t236" class="run"><span class="n"><a href="#t236">236</a></span><span class="t">        <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t237" class="pln"><span class="n"><a href="#t237">237</a></span><span class="t">            <span class="str">"##Automatically generated RISCV code, MIF08 &amp; CAP 2019\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t238" class="run"><span class="n"><a href="#t238">238</a></span><span class="t">        <span class="key">if</span> <span class="nam">comment</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t239" class="run"><span class="n"><a href="#t239">239</a></span><span class="t">            <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"##{} version\n"</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">comment</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t240" class="run"><span class="n"><a href="#t240">240</a></span><span class="t">        <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"\n\n##prelude\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t241" class="run"><span class="n"><a href="#t241">241</a></span><span class="t">        <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t242" class="pln"><span class="n"><a href="#t242">242</a></span><span class="t"><span class="str">        .text</span>&nbsp;</span><span class="r"></span></p>
    <p id="t243" class="pln"><span class="n"><a href="#t243">243</a></span><span class="t"><span class="str">        .globl {0}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t244" class="pln"><span class="n"><a href="#t244">244</a></span><span class="t"><span class="str">{0}:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t245" class="pln"><span class="n"><a href="#t245">245</a></span><span class="t"><span class="str">        addi sp, sp, -{1}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t246" class="pln"><span class="n"><a href="#t246">246</a></span><span class="t"><span class="str">        sd ra, 0(sp)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t247" class="pln"><span class="n"><a href="#t247">247</a></span><span class="t"><span class="str">        sd fp, 8(sp)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t248" class="pln"><span class="n"><a href="#t248">248</a></span><span class="t"><span class="str">        addi fp, sp, {1}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t249" class="pln"><span class="n"><a href="#t249">249</a></span><span class="t"><span class="str">        """</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_name</span><span class="op">,</span> <span class="nam">cardoffset</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t250" class="pln"><span class="n"><a href="#t250">250</a></span><span class="t">        <span class="com"># Stack in RiscV is managed with SP</span>&nbsp;</span><span class="r"></span></p>
    <p id="t251" class="run"><span class="n"><a href="#t251">251</a></span><span class="t">        <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"\n\n##Generated Code\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t252" class="run"><span class="n"><a href="#t252">252</a></span><span class="t">        <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t253" class="run"><span class="n"><a href="#t253">253</a></span><span class="t">            <span class="nam">i</span><span class="op">.</span><span class="nam">printIns</span><span class="op">(</span><span class="nam">output</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t254" class="run"><span class="n"><a href="#t254">254</a></span><span class="t">        <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"\n\n##postlude\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t255" class="run"><span class="n"><a href="#t255">255</a></span><span class="t">        <span class="nam">output</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t256" class="pln"><span class="n"><a href="#t256">256</a></span><span class="t"><span class="str">        ld ra, 0(sp)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t257" class="pln"><span class="n"><a href="#t257">257</a></span><span class="t"><span class="str">        ld fp, 8(sp)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t258" class="pln"><span class="n"><a href="#t258">258</a></span><span class="t"><span class="str">        addi sp, sp, {}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t259" class="pln"><span class="n"><a href="#t259">259</a></span><span class="t"><span class="str">        ret</span>&nbsp;</span><span class="r"></span></p>
    <p id="t260" class="pln"><span class="n"><a href="#t260">260</a></span><span class="t"><span class="str">"""</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">cardoffset</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t261" class="pln"><span class="n"><a href="#t261">261</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t262" class="run"><span class="n"><a href="#t262">262</a></span><span class="t">    <span class="key">def</span> <span class="nam">printDot</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">filename</span><span class="op">,</span> <span class="nam">view</span><span class="op">=</span><span class="key">False</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t263" class="pln"><span class="n"><a href="#t263">263</a></span><span class="t">        <span class="com"># Only used in Lab 5</span>&nbsp;</span><span class="r"></span></p>
    <p id="t264" class="mis show_mis"><span class="n"><a href="#t264">264</a></span><span class="t">        <span class="nam">graph</span> <span class="op">=</span> <span class="nam">nx</span><span class="op">.</span><span class="nam">DiGraph</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t265" class="mis show_mis"><span class="n"><a href="#t265">265</a></span><span class="t">        <span class="nam">names</span> <span class="op">=</span> <span class="nam">dict</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t266" class="mis show_mis"><span class="n"><a href="#t266">266</a></span><span class="t">        <span class="key">for</span> <span class="nam">i</span><span class="op">,</span> <span class="nam">instruction</span> <span class="key">in</span> <span class="nam">enumerate</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t267" class="mis show_mis"><span class="n"><a href="#t267">267</a></span><span class="t">            <span class="nam">names</span><span class="op">[</span><span class="nam">instruction</span><span class="op">]</span> <span class="op">=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">i</span><span class="op">)</span> <span class="op">+</span> <span class="str">"_"</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">instruction</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t268" class="pln"><span class="n"><a href="#t268">268</a></span><span class="t">        <span class="com"># nodes</span>&nbsp;</span><span class="r"></span></p>
    <p id="t269" class="mis show_mis"><span class="n"><a href="#t269">269</a></span><span class="t">        <span class="key">for</span> <span class="nam">instruction</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t270" class="mis show_mis"><span class="n"><a href="#t270">270</a></span><span class="t">            <span class="nam">graph</span><span class="op">.</span><span class="nam">add_node</span><span class="op">(</span><span class="nam">names</span><span class="op">[</span><span class="nam">instruction</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t271" class="pln"><span class="n"><a href="#t271">271</a></span><span class="t">        <span class="com"># edges</span>&nbsp;</span><span class="r"></span></p>
    <p id="t272" class="mis show_mis"><span class="n"><a href="#t272">272</a></span><span class="t">        <span class="key">for</span> <span class="nam">instruction</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_listIns</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t273" class="mis show_mis"><span class="n"><a href="#t273">273</a></span><span class="t">            <span class="key">for</span> <span class="nam">child</span> <span class="key">in</span> <span class="nam">instruction</span><span class="op">.</span><span class="nam">_out</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t274" class="mis show_mis"><span class="n"><a href="#t274">274</a></span><span class="t">                <span class="nam">graph</span><span class="op">.</span><span class="nam">add_edge</span><span class="op">(</span><span class="nam">names</span><span class="op">[</span><span class="nam">instruction</span><span class="op">]</span><span class="op">,</span> <span class="nam">names</span><span class="op">[</span><span class="nam">child</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t275" class="pln"><span class="n"><a href="#t275">275</a></span><span class="t">        <span class="com"># Add a fake "START" node to mark the entry of the CFG</span>&nbsp;</span><span class="r"></span></p>
    <p id="t276" class="mis show_mis"><span class="n"><a href="#t276">276</a></span><span class="t">        <span class="key">if</span> <span class="nam">i</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t277" class="mis show_mis"><span class="n"><a href="#t277">277</a></span><span class="t">            <span class="nam">graph</span><span class="op">.</span><span class="nam">add_node</span><span class="op">(</span><span class="str">"START"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t278" class="mis show_mis"><span class="n"><a href="#t278">278</a></span><span class="t">            <span class="nam">graph</span><span class="op">.</span><span class="nam">add_edge</span><span class="op">(</span><span class="str">"START"</span><span class="op">,</span> <span class="nam">names</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">_start</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t279" class="mis show_mis"><span class="n"><a href="#t279">279</a></span><span class="t">        <span class="nam">graph</span><span class="op">.</span><span class="nam">graph</span><span class="op">[</span><span class="str">'graph'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">dict</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t280" class="mis show_mis"><span class="n"><a href="#t280">280</a></span><span class="t">        <span class="nam">graph</span><span class="op">.</span><span class="nam">graph</span><span class="op">[</span><span class="str">'graph'</span><span class="op">]</span><span class="op">[</span><span class="str">'overlap'</span><span class="op">]</span> <span class="op">=</span> <span class="str">'false'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t281" class="mis show_mis"><span class="n"><a href="#t281">281</a></span><span class="t">        <span class="nam">nx</span><span class="op">.</span><span class="nam">drawing</span><span class="op">.</span><span class="nam">nx_agraph</span><span class="op">.</span><span class="nam">write_dot</span><span class="op">(</span><span class="nam">graph</span><span class="op">,</span> <span class="nam">filename</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t282" class="mis show_mis"><span class="n"><a href="#t282">282</a></span><span class="t">        <span class="nam">gz</span><span class="op">.</span><span class="nam">render</span><span class="op">(</span><span class="str">'dot'</span><span class="op">,</span> <span class="str">'pdf'</span><span class="op">,</span> <span class="nam">filename</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t283" class="mis show_mis"><span class="n"><a href="#t283">283</a></span><span class="t">        <span class="key">if</span> <span class="nam">view</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t284" class="mis show_mis"><span class="n"><a href="#t284">284</a></span><span class="t">            <span class="nam">gz</span><span class="op">.</span><span class="nam">view</span><span class="op">(</span><span class="nam">filename</span> <span class="op">+</span> <span class="str">'.pdf'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.0.3</a>,
            created at 2020-01-26 23:22
        </p>
    </div>
</div>
</body>
</html>
